UseMB=0		; Print Str$(MyReal8) works only in MB
if UseMB
	include \masm32\MasmBasic\MasmBasic.inc
else
	include \masm32\include\masm32rt.inc
endif
.686
.xmm
include \masm32\macros\timers.asm	; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]

fCmpFpu	PROTO: DWORD, :DWORD, :DWORD, :DWORD, :DWORD
fCmpXmm	PROTO: DWORD, :DWORD, :DWORD, :DWORD, :DWORD
fCmpXmmNf	PROTO: DWORD, :DWORD, :DWORD, :DWORD, :DWORD	; No frame variant

CodeSize MACRO algo
  pushad
  mov eax, offset &algo&_endp
  sub eax, offset &algo&_s
  print str$(eax), 9, " bytes for &algo&", 13, 10
  popad
ENDM

.data
fpMin	REAL8 ?
fpMax	REAL8 ?
fpMin2	REAL8 ?
fpMax2	REAL8 ?
R8	REAL8	1.23, 0.23, -1.23, 999.0, -999.0, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3
	REAL8	1.23, 0.23, 1.23, 999.0, -999.0, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3
	REAL8	1.23, 0.23, -1.23, 999.0, -999.0, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3
	REAL8	1.23, 0.23, 1.23, 999.0, -999.0, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3
	REAL8	1.23, 0.23, -1.23, 999.0, -999.0, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3
	REAL8	1.23, 0.23, 1.23, 999.0, -999.0, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3
	REAL8	1.23, 0.23, -1.23, 999.0, -999.0, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.23e3, -1.24e3, -1.23e3, -1.23e3
	REAL8	1.23, 0.23, 1.23, 999.0, -999.0, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.23e3, 1.24e3, 1.23e3

.code
start:	push 1
	call ShowCpu	; print brand string and SSE level
	SleepMs =	50	; test if anything changes when changing this
	LOOP_COUNT =	100000	; One Mio would be a typical value
	Magic = 123456
	finit
	if UseMB
			invoke fCmpFpu, offset R8, 8*16, offset fpMin, offset fpMax, Magic
			Print Str$("The min is %f\n", fpMin)
			Print Str$("The max is %f\n\n", fpMax)

			invoke fCmpXmm, offset R8, 8*16, offset fpMin2, offset fpMax2, Magic
			Print Str$("The min is %f\n", fpMin2)
			Print Str$("The max is %f\n\n", fpMax2)

			invoke fCmpXmmNf, offset R8, 8*16, offset fpMin2, offset fpMax2, Magic
			Print Str$("The min is %f\n", fpMin2)
			Print Str$("The max is %f\n\n", fpMax2)
	endif
	REPEAT 2
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				invoke fCmpFpu, offset R8, 8*16, offset fpMin, offset fpMax, Magic
		counter_end
;		shr eax, 7	; uncomment to get cycles per REAL8
		print str$(eax), 9, "cycles for fCmpFpu", 13, 10
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				invoke fCmpXmm, offset R8, 8*16, offset fpMin, offset fpMax, Magic
		counter_end
		print str$(eax), 9, "cycles for fCmpXmm", 13, 10
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				invoke fCmpXmmNf, offset R8, 8*16, offset fpMin, offset fpMax, Magic
		counter_end
		print str$(eax), 9, "cycles for fCmpXmmNf", 13, 10, 10
	ENDM
	CodeSize fCmpFpu
	CodeSize fCmpXmm
	CodeSize fCmpXmmNf
	inkey chr$(13, 10, "--- ok ---", 13)
	exit

;     C3     C2     C1     C0     Meaning
;     0      0      ?      0      ST > source
;     0      0      ?      1      ST < source
;     1      0      ?      0      ST = source
;     1      1      ?      1      ST not comparable to source
fCmpFpu_s:
fpHigh	REAL8 99.99e99
fCmpFpu proc uses ecx arrStart, arrSize, ptrMin, ptrMax, ignore
	mov edx, arrStart
	mov ecx, arrSize
	ffree st(7)
	fld fpHigh
	ffree st(7)
	fld st
	fchs
;	int 3	; Opt_Olly 2
	.Repeat
		fcom REAL8 ptr [edx]
		fnstsw ax	; C0=8, C1=9, C2=10, C3=14
		test ah, 1
		.if !Zero?
				fstp st
				fld REAL8 ptr [edx]
			.endif
		fxch
		fcom REAL8 ptr [edx]
		fnstsw ax
		test ah, 1
		.if Zero?
				fstp st
				fld REAL8 ptr [edx]
			.endif
		fxch
			add edx, 8
		dec ecx
	.Until Sign?
	fstp fpMax
	fstp fpMin
	ret
fCmpFpu endp
fCmpFpu_endp:

fCmpXmm_s:
fpHigh2	REAL8 99.999e99
fCmpXmm proc uses ecx arrStart, arrSize, ptrMin, ptrMax, ignore
	mov edx, arrStart
	mov ecx, arrSize
	movlpd xmm2, fpHigh2
	xorps xmm3, xmm3
	subsd xmm3, xmm2
;	int 3	; OPT_Olly 2
	.Repeat
		comisd xmm2, REAL8 ptr [edx]
		.if !Carry?
				movlpd xmm2, REAL8 ptr [edx]
			.endif
		comisd xmm3, REAL8 ptr [edx]
		.if Carry?
				movlpd xmm3, REAL8 ptr [edx]
			.endif
			add edx, 8
		dec ecx
	.Until Sign?
	mov eax, ptrMin
	movlpd REAL8 ptr [eax], xmm2
	mov eax, ptrMax
	movlpd REAL8 ptr [eax], xmm3
	ret
fCmpXmm endp
fCmpXmm_endp:


OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
fCmpXmmNf_s:
fpHigh2Nf	REAL8 99.999e99
fCmpXmmNf proc uses ecx arrStart, arrSize, ptrMin, ptrMax, ignore
	push ecx
	mov edx, [esp+8]	; arrStart
	mov ecx, [esp+12]	; arrSize
	movlpd xmm2, fpHigh2Nf
	xorps xmm3, xmm3
	subsd xmm3, xmm2
;	int 3	; OPT_Olly 2
	.Repeat
		comisd xmm2, REAL8 ptr [edx]
		.if !Carry?
				movlpd xmm2, REAL8 ptr [edx]
			.endif
		comisd xmm3, REAL8 ptr [edx]
		.if Carry?
				movlpd xmm3, REAL8 ptr [edx]
			.endif
			add edx, 8
		dec ecx
	.Until Sign?
	mov eax, [esp+16]	; ptrMin
	movlpd REAL8 ptr [eax], xmm2
	mov eax, [esp+20]	; ptrMax
	movlpd REAL8 ptr [eax], xmm3
	pop ecx
	ret 20
fCmpXmmNf endp
fCmpXmmNf_endp:
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Timings:
Intel(R) Pentium(R) 4 CPU 3.40GHz (SSE3)
4041    cycles for fCmpFpu
2665    cycles for fCmpXmm

4009    cycles for fCmpFpu
2680    cycles for fCmpXmm
